## bornagain 21.0+ds3

=== CMakeLists.txt ===
###########################################################################
# top-level CMakeLists.txt for building BornAgain
############################################################################

### CMake configuration

cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

set(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}/cmake
    ${CMAKE_SOURCE_DIR}/cmake/find
    ${CMAKE_SOURCE_DIR}/cmake/pack)
set(CONFIGURABLES_DIR ${CMAKE_SOURCE_DIR}/cmake/configurables)

include(BornAgain/Git)
message(STATUS "Git branch '${GIT_BRANCH}' at commit ${GIT_COMMIT}, tag: '${GIT_TAG}'")

include(commons/PreventInSourceBuilds)


### Project settings

project(BornAgain
    VERSION 21.0
    DESCRIPTION "BornAgain: simulate and fit reflectometry and grazing-incidence scattering."
    HOMEPAGE_URL https://www.bornagainproject.org
    LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)


### Options

# options that are on by default (switch off for accelerated builds of limited scope)
option(BORNAGAIN_PYTHON "Build with Python support" ON)
option(BA_GUI "Build a graphical user interface" ON)
option(BA_TIFF_SUPPORT "Tiff files read/write support" ON)
option(BA_TESTS "Build tests" ON)

# options that are off by default (switch on for additional functionality)
option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
option(CONFIGURE_EXAMPLES "Configure examples (requires ruby)" OFF)
option(CONFIGURE_DOXY "Configure Doxygen files" OFF)
option(ALLCONFIG "Regenerate Py wrappers, examples, Doxyfiles" OFF)
option(ZERO_TOLERANCE "Terminate compilation on warnings" OFF)
option(DEVELOPER_CHECKS "Checks required from developers but not from external users" OFF)
option(DEV "Development: turns ALLCONFIG, ZERO_TOLERANCE, DEVELOPER_CHECKS on" OFF)
option(BA_COVERAGE "Build with test coverage information" OFF)
option(BA_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
option(BA_TIDY "Invokes clang-tidy" OFF)
option(BATCH_MODE "Suppress some output" OFF)
option(ALGORITHM_DIAGNOSTIC "Let some algorithms set diagnostic variables" OFF)
option(BA_PY_PACKAGE "Build a Python wheel with the default Python platform, or a given Python platform (via BA_PY_PLATFORM)" OFF)
option(BUILD_DEBIAN "Build a debian package" OFF)
option(BA_APPLE_BUNDLE "Create a MacOS bundle" OFF)
option(BA_CPP_API "Install header files" OFF)

# options that set other options

set(BA_PY_PLATFORM "" CACHE INTERNAL "Path to Python platform to build a Python package")
string(STRIP "${BA_PY_PLATFORM}" BA_PY_PLATFORM)
if(BA_PY_PLATFORM)
    set(BA_PY_PACKAGE ON)
endif()

if(DEV)
    set(ALLCONFIG ON)
    set(ZERO_TOLERANCE ON)
    set(DEVELOPER_CHECKS ON)
endif()
if(ALLCONFIG)
    set(CONFIGURE_BINDINGS ON)
    set(CONFIGURE_EXAMPLES ON)
    set(CONFIGURE_DOXY ON)
endif()
if(BATCH_MODE)
    set(BA_GUI OFF)
endif()

# check compatibility of options

if(BA_TIDY AND BORNAGAIN_PYTHON)
    message(FATAL_ERROR "BA_TIDY is incompatible with BORNAGAIN_PYTHON")
endif()

if(BA_GUI AND NOT BORNAGAIN_PYTHON AND NOT BA_TIDY)
    message(FATAL_ERROR "BA_GUI without BORNAGAIN_PYTHON is currently unsupported"
        " (except with BA_TIDY)")
endif()

### Generator type (Release|Debug)

# Show info about generator type; set CMAKE_BUILD_TYPE if not given
if(CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Generator type: Multi-configuration generator")
else()
    message(STATUS "Generator type: Single-configuration generator")
endif()
message("    CMAKE_CONFIGURATION_TYPES: ${CMAKE_CONFIGURATION_TYPES}")
# The following is not correct/does not have any effect for multi-configuration generators.
# But when correcting this, be aware that CMAKE_BUILD_TYPE is used in more scripts!
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
    message("    CMAKE_BUILD_TYPE type not given - forced to 'Release'")
else()
    string(TOUPPER "${CMAKE_BUILD_TYPE}" _upper_build_type)
    set(BUILD_${_upper_build_type} 1)
endif()
message("    CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
configure_file("${PROJECT_SOURCE_DIR}/cmake/configurables/config_build.h.in"
    "${PROJECT_BINARY_DIR}/inc/config_build.h"
    @ONLY)


### Configure tests

if(BA_TESTS)
    # GoogleTest: `gtest_discover_tests` discovers tests by asking the _compiled test executable_
    # to enumerate its tests. `PRE_TEST` delays test discovery until just prior to test execution;
    # this avoids calling the executables during the build phase.
    set(CMAKE_GTEST_DISCOVER_TESTS_DISCOVERY_MODE PRE_TEST)

    include(CTest) # equivalent to "enable_testing() ???
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -LE Fullcheck)
       # => 'make check' is an alias for 'ctest'
    add_custom_target(fullcheck COMMAND ${CMAKE_CTEST_COMMAND})
       # => 'make check' is an alias for 'ctest'
   endif()


### Operating system

# introduce `LINUX` flag (along with `APPLE` and `WIN32`)
if(UNIX AND CMAKE_SYSTEM_NAME MATCHES Linux)
    set(LINUX ON)
endif()

# the host system must be Linux, Apple or Windows
if(NOT (LINUX OR APPLE OR WIN32))
    message(FATAL_ERROR "Operating system ${CMAKE_SYSTEM_NAME} is not supported")
endif()


### Further configuration

# function definitions
include(commons/GetFilenameComponent) # fct get_filename_component (overwrites CMake's built-in)
include(BornAgain/SwigLib) # fct SwigLib
include(BornAgain/MakeLib) # fct MakeLib

# main settings
include(BornAgain/Directories)
include(BornAgain/Dependences)

if(WIN32)
    include(BornAgain/InstallDll)
endif()

# Python
if(BORNAGAIN_PYTHON OR BA_PY_PACKAGE)
    include(multipython/PyDependences)
endif()

if(BORNAGAIN_PYTHON)
    include(BornAgain/PythonAPI)
endif()

if(BA_GUI)
    include(BornAgain/Qt)
    string(APPEND CMAKE_CXX_FLAGS " -DHAVE_QT=ON")
endif()

if(UNIX)
    if(LINUX)
        include(BornAgain/Linux)
    elseif(APPLE)
        include(BornAgain/MacOS)
    endif()
    include(BornAgain/NixInstall)
elseif(WIN32)
    include(BornAgain/Windows)
endif()

include(BornAgain/Config)

include(BornAgain/Compiler)
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CLANG ON)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(GCC ON)
    string(APPEND CMAKE_CXX_FLAGS " -fdiagnostics-color=always")
elseif(NOT WIN32)
    message(FATAL_ERROR "Unsupported compiler, id=${CMAKE_CXX_COMPILER_ID}")
endif()

if(ZERO_TOLERANCE)
    string(APPEND CMAKE_CXX_FLAGS " -Werror -Wfatal-errors")
endif()
if(ALGORITHM_DIAGNOSTIC)
    string(APPEND CMAKE_CXX_FLAGS " -DALGORITHM_DIAGNOSTIC=ON")
endif()
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -DBA_DEBUG")

# debug optimization
if(BA_DEBUG_OPTIMIZATION)
  include(commons/DebugOptimization)
endif()


### Configure source components

# library Fit
add_subdirectory(Fit/3rdparty)
add_subdirectory(Fit)

# other components
set(CoreComponents "PyCore;Base;Param;Sample;Resample;Device;Sim")
set(AllComponents "${CoreComponents};Img3D;GUI")

# code analysis
include(BornAgain/LineLength)
include(BornAgain/Format)
if(BA_COVERAGE)
  include(commons/CoverageFunction)
  include(BornAgain/Coverage)
endif()

# third-party code
add_subdirectory(3rdparty/common)
add_subdirectory(3rdparty/Core)
if(BA_GUI)
    add_subdirectory(3rdparty/GUI/qcustomplot)
endif()

# from here on our own code, occasionally scrutinized by clang-tidy
if(BA_TIDY)
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
endif()

# configure core component libraries
foreach(lib ${CoreComponents})
    add_subdirectory(${lib})
endforeach()
if(BORNAGAIN_PYTHON)
    add_dependencies(BornAgainFit swig_runtime)
    if (CONFIGURE_EXAMPLES)
        add_subdirectory(rawEx)
    endif()
endif()

# GUI
if(BA_GUI)
    add_subdirectory(Img3D)
    add_subdirectory(GUI)
    add_subdirectory(App)
endif()

# tests
if(BA_TESTS)
    add_subdirectory(Tests/Unit)
    if(BORNAGAIN_PYTHON)
        add_subdirectory(Tests/Examples)
        add_subdirectory(Tests/Py)
    endif()
    add_subdirectory(Tests/SimFactory)
    add_subdirectory(Tests/Functional)
    add_subdirectory(Tests/Suite)
endif()

# documentation
if(BORNAGAIN_PYTHON) # required for examples
    add_subdirectory(hugo)
endif()
add_subdirectory(Doc/man)
if(CONFIGURE_DOXY)
    add_subdirectory(Doc/Doxygen)
endif()


### Finalize

# after-install message
add_subdirectory(cmake)

# make package targets
include(BornAgain/Pack)

# build log
include(BornAgain/BuildLog)
install(FILES ${BA_BUILD_LOG} DESTINATION ${destination_share})
message(STATUS "BornAgain build log written to '${BA_BUILD_LOG}'")

message(STATUS "CMake done")

=== App/CMakeLists.txt ===
###############################################################################
# Builds BornAgain/GUI main executable
###############################################################################

if(WIN32)
    set(executable_name BornAgain)
else()
    set(executable_name bornagain)
endif()

set(source_files main.cpp AppOptions.cpp)

# -----------------------------------------------------------------------------
# Qt configuration
# -----------------------------------------------------------------------------
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

# -----------------------------------------------------------------------------
# executable icons
# -----------------------------------------------------------------------------
if(WIN32)
    set(system_addons bornagain.rc)
    if(NOT win32_console)
        set(executable_options WIN32)
    endif()
endif()

if(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE BornAgain.icns)
    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    if(BA_APPLE_BUNDLE)
        set(executable_options MACOSX_BUNDLE)
    endif()
endif()

# -----------------------------------------------------------------------------
# executable
# -----------------------------------------------------------------------------
add_executable(${executable_name}
    ${executable_options}
    ${source_files}
    ${system_addons})

# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------
target_link_libraries(${executable_name} PRIVATE BornAgainGUI ${Boost_LIBRARIES})
target_include_directories(${executable_name} PRIVATE ${CMAKE_SOURCE_DIR})

# -----------------------------------------------------------------------------
# extra target properties
# -----------------------------------------------------------------------------
if(WIN32)
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS /ENTRY:mainCRTStartup)
    if(win32_console)
        set_target_properties(${executable_name} PROPERTIES COMPILE_DEFINITIONS _CONSOLE)
    endif()
endif()

if(LINUX)
    # Add proper RPATHs as hints to load the dependencies at run-time
    # NOTE: Unlike `RUNPATH`, `RPATH` is searched for transitive dependencies;
    # ie. paths in RPATH will be considered for everything that is
    # dynamically loaded, even dependencies of dependencies.
    # see <https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=847298>
    set(link_flags "-Wl,--disable-new-dtags,-rpath,\$ORIGIN:\$ORIGIN/../lib")
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

if(APPLE)
    set(MACOSX_BUNDLE_IDENTIFIER org.bornagainproject.BornAgain)
    configure_file(${CONFIGURABLES_DIR}/MacOSXBundleInfo.plist.in
        ${BUILD_VAR_DIR}/Info.plist @ONLY)

    set_target_properties(${executable_name}
        PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${BUILD_VAR_DIR}/Info.plist)

    if(BA_APPLE_BUNDLE)
        set(link_flags
            "-Wl,-rpath,@loader_path/../lib -Wl,-rpath,@loader_path/../Frameworks/ \
-Wl,-rpath,@loader_path/../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    else()
        set(link_flags "-Wl,-rpath,\
@loader_path/../../../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    endif()
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()

# -----------------------------------------------------------------------------
# installation section
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(TARGETS ${executable_name} BUNDLE DESTINATION "." COMPONENT Applications)
else()
    install(TARGETS ${executable_name} RUNTIME DESTINATION ${destination_bin}
        COMPONENT Applications)
endif()

set(image_files
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.ico
    ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_48x48.png
    ${CMAKE_SOURCE_DIR}/GUI/images/BornAgain_64x64.png)
install(FILES ${image_files} DESTINATION ${destination_images} COMPONENT Applications)

# -----------------------------------------------------------------------------
# system dependent installation
# -----------------------------------------------------------------------------
if(BA_APPLE_BUNDLE)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/BornAgain.icns
        DESTINATION ${destination_bundle}/Contents/Resources/)
    install(FILES ${CMAKE_SOURCE_DIR}/cmake/configurables/qt.conf.mac
        DESTINATION ${destination_bundle}/Contents/Resources/
        RENAME qt.conf)

    # adjust MacOS bundle
    set(MACPKG_ROOT_DIR "${CMAKE_INSTALL_PREFIX}/${destination_prefix}")
    set(MACPKG_MAIN_EXE "${executable_name}")
    # list of required Qt plugins (paths relative to Qt root dir)
    set(MACPKG_QT_PLUGINS_RELDIR "${QT6_INSTALL_PLUGINS}")
    set(MACPKG_QT_PLUGINS
        platforms/libqcocoa.dylib
        iconengines/libqsvgicon.dylib
        imageformats/libqjpeg.dylib
        imageformats/libqsvg.dylib
        styles/libqmacstyle.dylib
        )
    # Qt plugins directory in within the MacOS bundle
    set(MACPKG_QT_PLUGINS_DIR PlugIns)  # conform to settings in `qt.conf`
    # convert CMake list to space-separated lists
    string(REPLACE ";" " " MACPKG_EXTRA_LIBS "${BA_Dependencies}")
    string(REPLACE ";" " " MACPKG_QT_PLUGINS "${MACPKG_QT_PLUGINS}")

    configure_file("${CMAKE_SOURCE_DIR}/devtools/deploy/mac/adjust_mac_bundle.zsh.in"
        "${BUILD_VAR_DIR}/adjust_mac_bundle.zsh" @ONLY)
endif()

if(WIN32)
    message(STATUS "Configuring the GUI package")

    foreach(comp ${QtComponents})
        set(QtComp Qt6::${comp})
        get_target_property(dll ${QtComp} LOCATION_Release)
        get_property(dll TARGET ${QtComp} PROPERTY LOCATION_Release)
        install(FILES ${dll} DESTINATION ${destination_lib} COMPONENT Libraries)
        message(STATUS "Install Qt lib ${QtComp} (${dll})")
    endforeach()

    # extract Qt root-dir
    # 'C:/Qt/6.2.4/msvc2019_64/lib/cmake/Qt6' => 'C:/Qt/6.2.4/msvc2019_64'
    file(TO_CMAKE_PATH "${Qt_DIR}" qt_dir_str)

    install(FILES
    ${Qt_DIR}/bin/opengl32sw.dll
    DESTINATION ${destination_lib} COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/platforms/qwindows.dll
    DESTINATION bin/platforms COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/iconengines/qsvgicon.dll
    DESTINATION bin/iconengines COMPONENT Libraries)
    install(FILES
    ${Qt_PLUGINS_DIR}/imageformats/qjpeg.dll
    ${Qt_PLUGINS_DIR}/imageformats/qsvg.dll
    DESTINATION bin/imageformats COMPONENT Libraries)

    set(QT_VISTA_STYLE ${Qt_PLUGINS_DIR}/styles/qwindowsvistastyle.dll)
    if(EXISTS ${QT_VISTA_STYLE})
        install(FILES ${QT_VISTA_STYLE}
                DESTINATION bin/styles COMPONENT Libraries)
    else()
        message(AUTHOR_WARNING File ${QT_VISTA_STYLE} not found.)
    endif()
    unset(QT_VISTA_STYLE)

endif()

if(LINUX)
    set(LINUXPKG_MAIN_EXE "${CMAKE_BINARY_DIR}/bin/${executable_name}")
    set(LINUXPKG_FRAMEWORK_DEST "${destination_lib}")

    configure_file(
        ${CMAKE_SOURCE_DIR}/devtools/deploy/linux/adjust_pkg_linux.sh.in
        ${BUILD_VAR_DIR}/adjust_pkg_linux.sh @ONLY)
endif()

# execute package-fixing script before CPack builds the final package file
configure_file(
    ${CMAKE_SOURCE_DIR}/cmake/configurables/FixPack.cmake.in
    ${BUILD_VAR_DIR}/FixPack.cmake @ONLY)

install(SCRIPT ${BUILD_VAR_DIR}/FixPack.cmake)

=== GUI/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building BornAgain/GUI libraries and executable
############################################################################

message(STATUS "Configuring BornAgain GUI")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(lib BornAgainGUI)

# --- source and include files ---

file(GLOB_RECURSE include_files View/Mask/ISceneAdaptor.h) # no clue why this is needed
file(GLOB_RECURSE source_files *.cpp)
file(GLOB_RECURSE forms_files *.ui)

set(resource_files
    gui.qrc
    View/SampleDesigner/SampleDesigner.qrc
    View/Mask/MaskWidgets.qrc
)

# --- Qt configuration ---------

qt_add_resources(RC_SRCS ${resource_files})

# --- definitions ------

if(BA_CRASHHANDLER)
    add_definitions(-DBA_CRASHHANDLER)
endif()

if(WIN32)
    string(APPEND CMAKE_CXX_FLAGS " -DBA_GUI_BUILD_DLL")
endif()

# --- make the library ---------

add_library(${lib} SHARED ${source_files} ${RC_SRCS} ${include_files} ${form_files})
#set_target_properties(${lib} PROPERTIES PREFIX ${libprefix} SUFFIX ${libsuffix})

# switch OFF Qt debug output in any configuration except DEBUG
target_compile_definitions(${lib} PUBLIC $<$<NOT:$<CONFIG:Debug>>:QT_NO_DEBUG_OUTPUT>)

if(BORNAGAIN_PYTHON)
    target_compile_definitions(${lib} PRIVATE -DBORNAGAIN_PYTHON)
endif()

# --- external dependences ---------

target_link_libraries(${lib}
    PUBLIC
    BornAgainSim
    BornAgainImg3D
    Qt6::Widgets
    Qt6::Core
    Qt6::Gui
    Qt6::OpenGLWidgets
    PRIVATE
    Qt6::PrintSupport
    qcustomplot
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()
target_include_directories(${lib} PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/GUI/qcustomplot
)

# --- installation ---------

set_target_properties(${lib} PROPERTIES
    PREFIX ${libprefix}
    SUFFIX ${libsuffix}
    OUTPUT_NAME ${lib}
    )

install(TARGETS ${lib}
    LIBRARY DESTINATION ${destination_lib} COMPONENT Libraries
    RUNTIME DESTINATION ${destination_lib} COMPONENT Libraries)

=== Tests/Functional/CMakeLists.txt ===
############################################################################
 # BornAgain/Tests/Functional/CMakeLists.txt (called from top-level CMakeLists.txt)
############################################################################

include_directories(${CMAKE_SOURCE_DIR}/Tests/Functional/TestMachinery)

add_subdirectory(Consistence)
add_subdirectory(CoreSpecial)
add_subdirectory(LibFit)
add_subdirectory(Fitting)

=== Tests/Functional/Consistence/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test TestCoreConsistence)

file(GLOB source_files *.cpp)

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)

target_include_directories(${test} PUBLIC
    ${BornAgainSim_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Functional.Consistence.)

=== Tests/Functional/CoreSpecial/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test TestCoreSpecial)

set(source_files
    FourierTransformationTest.cpp
    CoreIOPathTest.cpp
    )

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_include_directories(${test}
    PUBLIC
    ${CMAKE_SOURCE_DIR}/Tests/Unit/utilities
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainSim gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX "Functional.CoreSpecial.")

=== Tests/Functional/Fitting/CMakeLists.txt ===
#   ************************************************************************************************
#
#   BornAgain: simulate and fit scattering at grazing incidence
#
#!  @file      Tests/Functional/Core/Fitting/CMakeLists.txt
#!  @brief     Builds fit tests (Core.Fitting.*)
#
#              GTestWrapper/TestAll.cpp provides main, which essentially runs RUN_ALL_TESTS().
#              RUN_ALL_TESTS is a gtest macro that runs tests defined by TEST_F macros.
#
#              FitTests.cpp uses such TEST_F macros to define our standard test cases.
#
#!  @homepage  http://www.bornagainproject.org
#!  @license   GNU General Public License v3 or higher (see COPYING)
#!  @copyright Forschungszentrum Jülich GmbH 2018
#!  @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
#
#   ************************************************************************************************

include(GoogleTest) # provides gtest_discover_tests

set(test TestCoreFitting)

file(GLOB source_files *.cpp)

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_include_directories(${test}
    PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Functional.Fitting.)

=== Tests/Functional/LibFit/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test TestMinimizers)

file(GLOB source_files *.cpp)

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_include_directories(${test}
    PUBLIC ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainFit gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Functional.Fit.)

=== Tests/Suite/GUI/CMakeLists.txt ===
#   ************************************************************************************************
#
#   BornAgain: simulate and fit scattering at grazing incidence
#
#!  @file      Tests/Functional/GUI/Suite/CMakeLists.txt
#!  @brief     Builds GUI standard tests.
#
#              GTestWrapper/TestAll.cpp provides main, which essentially runs RUN_ALL_TESTS().
#              RUN_ALL_TESTS is a gtest macro that runs tests defined by TEST_F macros.
#
#              .../Suite/RunTest.cpp includes .../Suite/Standard.Test which uses such TEST_F macros
#              to define our standard test cases.
#
#              ./Check.cpp provides a callback function that executes one GUI tests:
#              Run a given simulation directly, and through GUI model, and compare results.
#
#!  @homepage  http://www.bornagainproject.org
#!  @license   GNU General Public License v3 or higher (see COPYING)
#!  @copyright Forschungszentrum Jülich GmbH 2018
#!  @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
#
#   ************************************************************************************************

include(GoogleTest) # provides gtest_discover_tests

set(test TestGuiSuite)

set(source_files Check.cpp ../Common/RunTest.cpp ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)

add_executable(${test} ${source_files})
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_compile_options(${test} PUBLIC -DGUI_STD_TEST -DTESTNAME=GUI)
target_compile_definitions(${test} PUBLIC DISABLE_DISTRIBUTION_TESTS)

target_include_directories(${test} PUBLIC
    ${BornAgainGUI_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainGUI BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Suite.)

=== Tests/Suite/Persist/CMakeLists.txt ===
#   ************************************************************************************************
#
#   BornAgain: simulate and fit scattering at grazing incidence
#
#!  @file      Tests/Functional/Persist/CMakeLists.txt
#!  @brief     Builds Core standard tests.
#
#              GTestWrapper/TestAll.cpp provides main, which essentially runs RUN_ALL_TESTS().
#              RUN_ALL_TESTS is a gtest macro that runs tests defined by TEST_F macros.
#
#              .../Suite/RunTest.cpp includes .../Suite/Standard.Test which uses such TEST_F macros
#              to define our standard test cases.
#
#              ./Check.cpp provides a callback function that executes one Core tests:
#              Run a given simulation, and compare result with reference data.
#
#!  @homepage  http://www.bornagainproject.org
#!  @license   GNU General Public License v3 or higher (see COPYING)
#!  @copyright Forschungszentrum Jülich GmbH 2018
#!  @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
#
#   ************************************************************************************************

include(GoogleTest) # provides gtest_discover_tests

set(test TestSuitePersist)

set(source_files Check.cpp ../Common/RunTest.cpp ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)

add_executable(${test} ${source_files})
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_compile_definitions(${test} PUBLIC DISABLE_DISTRIBUTION_TESTS -DTESTNAME=Persist)
target_include_directories(${test} PUBLIC
    ${BornAgainSim_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Suite.)

=== Tests/Suite/Py/CMakeLists.txt ===
#   ************************************************************************************************
#
#   BornAgain: simulate and fit scattering at grazing incidence
#
#!  @file      Tests/Functional/Python/Suite/CMakeLists.txt
#!  @brief     Builds Python standard tests.
#
#              GTestWrapper/TestAll.cpp provides main, which essentially runs RUN_ALL_TESTS().
#              RUN_ALL_TESTS is a gtest macro that runs tests defined by TEST_F macros.
#
#              .../Suite/RunTest.cpp includes .../Suite/Standard.Test which uses such TEST_F macros
#              to define our standard test cases.
#
#              ./Check.cpp provides a callback function that executes one Python tests:
#              Export a simulation to Python, run that Python script, and compare the
#              result with a direct simulation in the C++ core.
#
#!  @homepage  http://www.bornagainproject.org
#!  @license   GNU General Public License v3 or higher (see COPYING)
#!  @copyright Forschungszentrum Jülich GmbH 2018
#!  @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
#
#   ************************************************************************************************

include(GoogleTest) # provides gtest_discover_tests

set(test TestPySuite)

set(source_files Check.cpp
    ../Common/RunTest.cpp
    ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)

add_executable(${test} ${source_files})
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_compile_options(${test} PUBLIC -DPYTHON_STD_TEST -DTESTNAME=Py)
target_compile_definitions(${test} PUBLIC DISABLE_DISTRIBUTION_TESTS)

target_include_directories(${test} PUBLIC
    ${BornAgainSim_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Suite. PROPERTIES LABELS "XL")

=== Tests/Unit/Numeric/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test UnitTestNumeric)

if(MSVC)
    string(APPEND CMAKE_CXX_FLAGS " -DGTEST_LINKED_AS_SHARED_LIBRARY=1")
endif()

file(GLOB source_files "*.cpp" ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)

add_executable(${test} ${source_files})
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_include_directories(${test} PUBLIC
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include
    ${CMAKE_SOURCE_DIR}/Tests/Unit/utilities)
target_link_libraries(${test} BornAgainSim gtest)
if(GCC)
    target_compile_options(${test} PUBLIC "-Wno-deprecated-copy")
endif()

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX "Numeric." PROPERTIES  LABELS "XL")

=== debian/changelog ===
bornagain (21.0+ds3-2) unstable; urgency=medium

  * Bug fix: "bornagain executable can't find _libBornAgainGUI.so",
    thanks to Heine Larsen (Closes: #1043337).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Aug 2023 17:55:37 +0200

bornagain (21.0+ds3-1) unstable; urgency=medium

  * New upstream version 21.0+ds3
  * refresh the patch series
  * d/rules: move all the install target into the rules file
  * Bug fix: "please add autopkgtests (to add coverage for
    python3-numpy)", thanks to Sandro Tosi (Closes: #1035141).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Aug 2023 16:27:16 +0200

bornagain (20.2+ds3-2) unstable; urgency=medium

  * Patch to increase error margins for testsuite.
  * Fix Hugo build.

 -- Roland Mas <lolando@debian.org>  Tue, 08 Aug 2023 16:39:53 +0200

bornagain (20.2+ds3-1) unstable; urgency=medium

  * New upstream release.
  * Add myself as uploader.
  * Use newly-packaged libheinz and libformfactor.
  * Use Qt6.
  * Update install paths for *.pc, *.so, *.cmake files.
  * Build HTML docs with Hugo (several patches needed).
  * Update debian/copyright (thanks, Lintian!).
  * Re-enable testsuite (hence the build-dependency on clang-format).
  * Re-enable dh_dwz.

 -- Roland Mas <lolando@debian.org>  Sun, 30 Jul 2023 12:43:39 +0200

bornagain (1.19.0-4) unstable; urgency=medium

  [ Neil Williams ]
  * Update control to add Debian PaN maintainers

  [ Sébastien Delafond ]
  * d/control: use Freexian Packaging Team instead of seb@debian.org in Uploaders

  [ Picca Frédéric-Emmanuel ]
  * d/watch: upstream migrated to gitlab

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 24 Jul 2023 14:57:07 +0200

=== debian/control ===
Source: bornagain
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Mika Pflüger <debian@mikapflueger.de>,
 Freexian Packaging Team <team+freexian@tracker.debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends: clang-format <!nocheck>,
               cmake,
               debhelper-compat (= 12),
               dh-python,
               doxygen-latex <!nodoc>,
               hugo <!nodoc>,
               libboost-all-dev,
               libcerf-dev,
               libeigen3-dev,
               libformfactor-dev,
               libfftw3-dev,
               libgsl0-dev,
               libheinz-dev,
               libtiff-dev,
               libxkbcommon-dev,
               libyaml-cpp-dev,
               python3-dev <!nopython>,
               python3-distutils <!nopython>,
               python3-matplotlib <!nopython>,
               python3-numpy <!nopython>,
               python3-pip <!nopython>,
               python3-yaml <!nopython>,
               qt6-base-dev,
               qt6-svg-dev,
               swig <!nopython>,
               texlive-fonts-extra <!nodoc>,
               texlive-xetex <!nodoc>,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/bornagain
Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
Homepage: https://bornagainproject.org/

Package: bornagain
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-bornagain
Description: Simulate and fit X-ray and neutron GISAS -- binary
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org

Package: python3-bornagain
Architecture: any
Depends: python3-matplotlib,
         python3-numpy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Simulate and fit X-ray and neutron GISAS -- Python3
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the Python bindings for use in scripts.

Package: bornagain-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${shlibs:Depends}, libjs-bootstrap,
 libjs-jquery, libjs-popper.js, fonts-open-sans, fonts-roboto, fonts-font-awesome
Recommends: bornagain
Multi-Arch: foreign
Description: Simulate and fit X-ray and neutron GISAS -- doc
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the BornAgain documentation.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) -DCONFIGURE_MANPAGE=ON -DBORNAGAIN_MPI=ON

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=ON -DPython_ADDITIONAL_VERSIONS="3.9 3.8"
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r

execute_after_dh_auto_build:
	cd hugo && hugo

execute_after_dh_clean:
	rm -rf hugo/public hugo/.hugo_build.lock
	find auto -name *.pyc -delete

execute_before_dh_install:
	# bornagain-doc
	dh_install -p bornagain-doc usr/share/BornAgain/Examples/* usr/share/doc/bornagain/examples/
	dh_install -p bornagain-doc hugo/public/* usr/share/doc/bornagain/html

	#  bornagain
	dh_install -p bornagain usr/bin/bornagain
	dh_install -p bornagain usr/lib/*/bornagain/_libBornAgainGUI.so
	dh_install -p bornagain usr/share/BornAgain/Images/* usr/share/bornagain/images/
	dh_install -p bornagain usr/share/man/

	# python3-bornagain
	dh_install -p python3-bornagain -X_libBornAgainGUI.so usr/lib/*/bornagain/*.so
	dh_install -p python3-bornagain usr/lib/python3/*
